﻿// SameItemsSelection.jsx

// Eng
/*
The script selects objects on the current spread that match the design of the selected frame, let's call it a reference.
The design elements of the reference object, which will be the criteria for matching, are checked.
After clicking on the 'Find objects' button, the frames that match the standard according to the selected criteria will be highlighted.

The search is performed only among individual objects of the types 'TextFrame', 'Rectangle', 'Polygon', 'GraphicLine', 'Oval'. The anchored object can be a reference, 
but it will not be included in the group of found objects. Groups are excluded from consideration. 

Criteria 'Fill' and 'Stroke' — the colors and the percentage of filling of objects are taken into account. As for the contour line, in addition to colors and shades, line thicknesses are compared, but the line type is not analyzed.
The criterion 'The same size' — the difference in size does not exceed one point. The program analyzes the dimensions of the object (bounding box), not the actual size: 
two identical squares rotated at different angles will have mismatched dimensions, and for this reason will not be shown as objects with the same size.
If the 'Objects of the same type' checkbox is selected, then after performing the search, the help tip of this checkbox will contain the name of the type of the selected object.

The search result is either a selected group of objects, or a message that no matches were found. If a match is found, in the tooltip to the button [?] there will be information about the number of matches found.

Whether or not the reference itself will be included in this selection (if it is not an anchored object) depends on the state of the checkbox to the left of the 'Find Objects' button. 
While the selection based on the search results is active, you can use this checkbox to place the standard in the selection and exclude it from it. 
Each time this checkbox is switched, the fill color of the reference frame is switched in the sequence red-green-blue, then the original color is returned: 
this is a reminder of which frame was selected before searching for similar objects.

https://shop.dotextok.ru/en/  |  dotextok@gmail.com

*/
var m01 = "Similar objects";
var m02 = "Match criteria:";
var m03 = "Fill";
var m04 = "Stroke";
var m05 = "Matching object styles";
var m06 = "Objects on the same layer";
var m07 = "Objects of the same type";
var m08 = "The same size";
var m09 = "Don't search on locked layers";
var m10 = "When the check box is selected, the reference object is not included in the selection";
var m11 = "Find objects";
var m12 = "The script selects objects on the current spread that match the design of the selected frame, let's call it a reference.\nThe design elements of the reference object, which will be the criteria for matching, are checked.\nAfter clicking on the 'Find objects' button, the frames that match the standard according to the selected criteria will be highlighted.\n\nThe search is performed only among individual objects of the types 'TextFrame', 'Rectangle', 'Polygon', 'GraphicLine', 'Oval'. The anchored object can be a reference, but it will not be included in the group of found objects. Groups are excluded from consideration. \n\nCriteria 'Fill' and 'Stroke' — the colors and the percentage of filling of objects are taken into account. As for the contour line, in addition to colors and shades, line thicknesses are compared, but the line type is not analyzed.\nThe criterion 'The same size' — the difference in size does not exceed one point. The program analyzes the dimensions of the object (bounding box), not the actual size: two identical squares rotated at different angles will have mismatched dimensions, and for this reason will not be shown as objects with the same size.\nIf the 'Objects of the same type' checkbox is selected, then after performing the search, the help tip of this checkbox will contain the name of the type of the selected object.\n\nThe search result is either a selected group of objects, or a message that no matches were found. If a match is found, in the tooltip to the button [?] there will be information about the number of matches found.\n\nWhether or not the reference itself will be included in this selection (if it is not an anchored object) depends on the state of the checkbox to the left of the 'Find Objects' button. While the selection based on the search results is active, you can use this checkbox to place the standard in the selection and exclude it from it. \nEach time this checkbox is switched, the fill color of the reference frame is switched in the sequence red-green-blue, then the original color is returned: this is a reminder of which frame was selected before searching for similar objects.\n\nhttps://shop.dotextok.ru/en/  |  dotextok@gmail.com\n\n";
var m13 = "Highlighting similar objects";
var m14 = "No matches found";
var m15 = "Number of matches found: ";
var m16 = "No open documents";
var m17 = "The reference object must be selected";
var m18 = "A group of objects cannot be a reference item";
var m19 = "The program works with such objects:";
var m20 = "The type of the selected object '";
var m21 = "', this name is not in the list of names of processed objects";
///

#targetengine "SameItemsSelection" 

var programTitul = m01;

var ProgressBar = function(title) { // ProgressBar
var w = new Window('palette', title, {x:0, y:0, width:740, height:58},{closeButton: true});
pb = w.add('progressbar', {x:20, y:37, width:700, height:12});
w.center();
this.reset = function(maxValue) {
    pb.value = 0; 
    pb.maxvalue = maxValue;
    w.show();
    w.update();
    };
this.set = function(value) {
    pb.value = value;
    w.show();
    w.update();
    };
this.hit = function() {++pb.value; w.update();};
this.hide = function() {w.hide();};
this.close = function() {w.close();};
} // ProgressBar
////////////////////////////
var pgIt;
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll; // см. http://adobeindesign.ru/2008/10/24/restore-ui/ 
if (testOpenDoc () == null) exit();
var doc = app.activeDocument;
var sel;
var myCurrentHorUnits = doc.viewPreferences.horizontalMeasurementUnits;
var myCurrentVertUnits = doc.viewPreferences.verticalMeasurementUnits;
doc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
doc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
///
var constNames = "TextFrame, Rectangle, Polygon, GraphicLine, Oval";  
var founded = [];
while (founded.length > 0) founded.pop();
var actionID = -1;
var etalonP;
var theSpread;  
var pageItems = [];
var pageItemsLength;
while (pageItems.length > 0) pageItems.pop();
///
var w = new Window ("palette",programTitul);
w.alignChildren = ["fill", "fill"];
w.orientation = "column";
var titul = w.add("statictext", undefined, m02);
var fill = w.add("checkbox", undefined, m03);
fill.value = true;
var stroke = w.add("checkbox", undefined, m04);
stroke.value = true;
var os = w.add("checkbox", undefined, m05);  
os.value = false;
var sameLayers = w.add("checkbox", undefined, m06); 
sameLayers.value = false;
///
var sameTypes = w.add("checkbox", undefined, m07); 
sameTypes.value = false;
var sameSizes =  w.add("checkbox", undefined, m08);
sameSizes.value = false;
separator1 = w.add ("panel"); 
separator1.minimumSize.height = separator1.maximumSize.height = 1;
separator1.alignment = ["fill", "fill"]; 
var locked = w.add("checkbox", undefined, m09);
locked.value = false;
var buttonGroup = w.add("group");
buttonGroup.orientation = "row";
buttonGroup.alignChildren = ["fill", "bottom"];
var andEtalon = buttonGroup.add("checkbox");
andEtalon.helpTip = m10;
var action = buttonGroup.add("button", [0,0,125,28], m11);
buttonGroup.add("statictext", undefined, "");
var infoGroup = buttonGroup.add("group");
var info = infoGroup.add("button", [0,0,28,28], "?");
///
info.onClick = function () { // info.onClick
var infoText = m12;    
alert(infoText, m13);
} // info.onClick
///
function testCheckboxes () { // testCheckboxes
if (!fill.value && !stroke.value && !os.value && !sameSizes.value && !sameTypes.value  && !sameLayers.value) action.enabled = false; else action.enabled = true;
} // testCheckboxes
///
fill.onClick = function () { testCheckboxes (); }
///
stroke.onClick = function () { testCheckboxes (); }
///
os.onClick = function () { testCheckboxes (); }
///
sameSizes.onClick = function () { testCheckboxes (); }
///
sameLayers.onClick = function () { testCheckboxes (); }
///
sameTypes.onClick = function () { testCheckboxes (); }
///
action.onClick = function () { // action.onClick   
info.helpTip = "";
if (testOpenDoc() == null) return;
if (testSelelction() == null) return;
actionID = sel.id;
theSpread = doc.windows[0].activeSpread;  
pageItems = theSpread.pageItems.everyItem().getElements();
pageItemsLength = pageItems.length;
while (founded.length > 0) founded.pop();
pBar = new ProgressBar(programTitul);  
pBar.reset(pageItemsLength);
var selGB = sel.geometricBounds;
var selW = Math.abs(selGB[1] - selGB[3]);
var selH = Math.abs(selGB[0] - selGB[2]);
for (var p = 0; p < pageItemsLength; p++, pBar.hit()) { // p++
    if (pageItems[p].constructor.name == "Group") continue;
    if (constNames.match(pageItems[p].constructor.name) == null) continue;
    if (pageItems[p].id == actionID) { etalonP = p; continue; }
    if ((locked.value == true) && pageItems[p].itemLayer.locked) { continue; }    
    if ((fill.value == true) && ((pageItems[p].fillColor != sel.fillColor) || (pageItems[p].fillTint != sel.fillTint))) continue; 
    if ((stroke.value == true) && ((pageItems[p].strokeColor != sel.strokeColor) || (pageItems[p].strokeTint != sel.strokeTint) || (pageItems[p].strokeWeight != sel.strokeWeight))) continue;    
    if ((os.value == true) && (pageItems[p].appliedObjectStyle.id != sel.appliedObjectStyle.id)) continue;
    if ((sameTypes.value == true) && (pageItems[p].constructor.name != sel.constructor.name)) { continue; } 
    if ((sameLayers.value == true) && (pageItems[p].itemLayer.name != sel.itemLayer.name)) { continue; }     
    if (sameSizes.value == true) { // sameSizes.value
        var piGB = pageItems[p].geometricBounds;
        var piW = Math.abs(piGB[1] - piGB[3]);
        var piH = Math.abs(piGB[0] - piGB[2]);
        if ((Math.abs(selW - piW) > 1) || (Math.abs(selH - piH) > 1)) continue;
        } // sameSizes.value
    founded.push(p);    
    } // p++
pBar.close();
if (founded.length == 0) {
    alert(m14, programTitul);
    info.helpTip = "";
    return;
    }
else showSelection();
} // action.onClick
///
function showSelection () { // showSelection
info.helpTip = m15 + founded.length;    
app.selection = NothingEnum.NOTHING;
for (var f = 0; f < founded.length; f++) { app.select(pageItems[founded[f]], SelectionOptions.ADD_TO); }
if (andEtalon.value == false) app.select(pageItems[etalonP], SelectionOptions.ADD_TO);
} // showSelection
///
andEtalon.onClick = function () { // andEtalon.onClick
if (action.enabled == false) return; // все флажки сброшены  
if (app.selection[0] == null) return; // выделение снято
if (founded.length == 0 || pageItemsLength == 0) return; 
var usedColor, _r, _g, _b, _w;
usedColor = sel.fillColor;
 _r = app.activeDocument.colors.add ({model:ColorModel.SPOT, space:ColorSpace.RGB, colorValue:[255, 0, 0]});
 _g = app.activeDocument.colors.add ({model:ColorModel.SPOT, space:ColorSpace.RGB, colorValue:[0, 255, 0]});
 _b = app.activeDocument.colors.add ({model:ColorModel.SPOT, space:ColorSpace.RGB, colorValue:[0, 0, 255]});
 _w = app.activeDocument.colors.add ({model:ColorModel.SPOT, space:ColorSpace.RGB, colorValue:[255, 255, 255]});
var _time = 175;
sel.fillColor = _r; $.sleep(_time);
sel.fillColor = _w; $.sleep(_time);
sel.fillColor = _g; $.sleep(_time);
sel.fillColor = _w; $.sleep(_time);
sel.fillColor = _b; $.sleep(_time);
sel.fillColor = _w; $.sleep(_time);
sel.fillColor = usedColor;
_r.remove(); 
_g.remove(); 
_b.remove(); 
_w.remove(); 
showSelection();
} // andEtalon.onClick
///
w.onClose = function () { // w.onClose
// try/catch  на случай, если файл закрыли, а окно программы осталось    
try {  
    doc.viewPreferences.horizontalMeasurementUnits = myCurrentHorUnits;
    doc.viewPreferences.verticalMeasurementUnits = myCurrentVertUnits;
    }
catch (e) { }
} // w.onClose 
///
w.show();
/////////////
function testOpenDoc () { // testOpenDoc
if (app.documents.length == 0) {
    alert (m16,programTitul);
    return null;
    }    
 return 0;   
} // testOpenDoc
////
function testSelelction () { // testSelelction  
sel = app.selection[0];
if ((sel == null) || (sel.hasOwnProperty("geometricBounds") != true) || (app.selection.length !=1)) { // == null
    alert(m17,programTitul);
    return null;    
    }  // == null
var name = sel.constructor.name;
if (name == "Group") {
    alert(m18,programTitul);
    return null;     
    }
if (constNames.match(name) == null) {
    alert(m19 + "\n" + constNames + ".\n" + m20 + name + m21,programTitul);    
    return null;       
    }
app.documents[0].layoutWindows[0].zoom(ZoomOptions.FIT_SPREAD);
if (sameTypes.value == true) sameTypes.helpTip = sel.constructor.name; else sameTypes.helpTip = "";
return 0;
} // testSelelction    
////



